window.saveFCMToken = (token) => {

    return new Promise((resolve, reject) => {
        let rowToSave = {
            UUID : device.uuid,
            PLATFORM : device.platform,
            TOKEN : token,
            CDOPERADOR : localStorage.getItem('CDOPERADOR'),
        };

        let xhr = new XMLHttpRequest();
        let baseUrl = window.serviceUrls.find(serviceUrl => serviceUrl.package === 'sup');
        xhr.open('POST', baseUrl + "/alcadasApp", true);
        xhr.setRequestHeader('Content-Type', 'application/json');
        xhr.withCredentials = true;
        xhr.onerror = () => reject(false);
        xhr.onreadystatechange = () => {
            if (xhr.readyState === XMLHttpRequest.DONE) {
                if (xhr.status === 200)
                    resolve(xhr.response);
                else
                    reject(xhr.response)
            }
        };

        xhr.send(JSON.stringify(params));
    })

};


document.addEventListener("deviceready", () => {

    let requestToken = () => {
        window.FirebasePlugin.getToken((token) => {
            localStorage.setItem('fcmToken', token);
            window.shouldUpdateFCMToken = true;
            // saveFCMToken().then(r => console.log(r));
            console.log(" ORIGIN getToken", token);
        }, (error) => {
            console.error(error);
        });
    };

    if(window.FirebasePlugin){
        let fcmToken = localStorage.getItem('fcmToken');
        if (!fcmToken) {
            if(device && 'platform' in device && device.platform.toLowerCase() === 'ios') {
                window.FirebasePlugin.grantPermission(requestToken);
            } else {
                requestToken();
            }
        }
        
        window.FirebasePlugin.onTokenRefresh((token) => {
            localStorage.setItem('fcmToken', token);
            window.shouldUpdateFCMToken = true;
            // saveFCMToken().then(r => console.log(r));
            console.log(" ORIGIN tokenRefresh", token);
        }, (error) => {
            console.error(error);
        });
        
        /**
         * directly receives the notifications from firebase and triggers the listener for the main applications
         * or enqueue them if the listener is not attached yet 
         */
        window.FirebasePlugin.onNotificationOpen(function(notification) {
            if(window.FirebasePlugin.__isListernerAttached){
                window.FirebasePlugin.__dispatchNotificationEvent(notification);
            } else {
                window.FirebasePlugin.notificationsDataQueue.push(notification);
            }
            console.log(notification);
        }, function(error) {
            console.error(error);
        });
        
        /**
         * triggers pending events 
         */
        window.FirebasePlugin.confirmListenerAttached = () => {
            window.FirebasePlugin.__dispatchNotificationEvent();
            window.FirebasePlugin.__isListernerAttached = true;
        };

        window.FirebasePlugin.__isListernerAttached = false;

        /**
         * @type {FirebaseNotificationData}
         */
        window.FirebasePlugin.notificationsDataQueue = [];
        

        window.FirebasePlugin.__dispatchNotificationEvent = (notificationToDispatch) => {
            if(notificationToDispatch){
                let notificationOpenEvent = new CustomEvent('notificationopen', { 'detail': notificationToDispatch });
                document.dispatchEvent(notificationOpenEvent);
            } else {
                while(window.FirebasePlugin.notificationsDataQueue.length) {
                    let notification = window.FirebasePlugin.notificationsDataQueue.pop();
                    let notificationOpenEvent = new CustomEvent('notificationopen', { 'detail': notification });
                    document.dispatchEvent(notificationOpenEvent);
                }
            }
        };

    }
}, false);

