var TasksController = function(LoginService, ScreenService, templateManager, ZHPromise) {

    this.changeFilter = function(newData) {
        var widget = templateManager.container.getActiveWidget();
        let shouldOpenTasksContainer = templateManager.container.name !== newData.containerName;
        if (shouldOpenTasksContainer) {
            ScreenService.openWindow('tasks');
        }
        // setTimeout(function() {
        let loadData = () => {
            widget = templateManager.container.getActiveWidget();
            var filter = widget.dataSourceFilter;
            var filterElement = filter.find(function(filterEl) {
                return filterEl.name === 'IDAPROVADO';
            });
            filterElement.value = newData.filterBy;
            widget.title = newData.name;
            let CDOPERADORFilter = widget.dataSourceFilter.find(filter => filter.name === 'CDOPERADOR');
            if (newData.filterBy === 'PENDENTE') {
                widget.fields.forEach(function(action) {
                    action.isVisible = true;
                });
                CDOPERADORFilter.value = localStorage.getItem('CDOPERADOR');
                widget.filterValues.OVERVIEW = 'overviewInactive';
                let OVERVIEWFilterProperties = widget.filterProperties.fields.find(field => field.name === 'OVERVIEW');
                OVERVIEWFilterProperties.disabled = true;
            } else {
                widget.fields.forEach(function(action) {
                    action.isVisible = false;
                });
                let OVERVIEWFilterProperties = widget.filterProperties.fields.find(field => field.name === 'OVERVIEW');
                OVERVIEWFilterProperties.disabled = false;
                // CDOPERADORFilter.value = "T";
            }
            scroll(0, 0);
            widget.reload();
        };
        if (shouldOpenTasksContainer) {
            setTimeout(loadData, 100);
        } else {
            loadData();
        }
        // }, 100);
    };

    this.openDetailTab = function(widget) {
        widget.currentRow = widget.parent.parent.currentRow;

        let zhLoader = document.querySelector('div[data-zh-loader]');

        let loadPromises = [];
        let timelineWidget = widget.container.getWidget('Timeline');
        let itensWidget = widget.container.getWidget('itens');

        loadPromises.push(this.openTimeline(timelineWidget));
        loadPromises.push(this.openItens(itensWidget));

        ZHPromise.all(loadPromises).finally(function() {
            setTimeout(function() {
                zhLoader.style.display = 'none';
                zhLoader.classList.remove('force-display-none');
            }, 300);
        });
    };
    this.loadedChartDataSource = function(widget) {
        let field = widget.getField('approvalChart');

        let itens = field.itens;
        let total = itens.find(function(filterEl) {
            return filterEl.isTotal === true;
        });
        let start = itens.find(function(filterEl) {
            return filterEl.isStartValue === true;
        });
        let curAdition = itens.find(function(filterEl) {
            return filterEl.isCurrAdition === true;
        });

        // start.valor = widget.currentRow[start.id] ? widget.currentRow[start.id] : widget.dataSource.data[0][start.id];
        // total.valor = widget.currentRow[total.id] ? widget.currentRow[total.id] : widget.dataSource.data[0][total.id];
        start.valor = widget.dataSource.data[0][start.id];
        curAdition.valor = widget.dataSource.data[0].VRTOTALAF;
        total.valor = widget.dataSource.data[0][total.id];

        if (start.valor >= total.valor) {
            field.itens[0].color = "#DB0000";
        } else {
            field.itens[0].color = "#0039A6";
        }

        if (curAdition.valor >= total.valor) {
            field.itens[1].color = "#DB0000";
        } else {
            field.itens[1].color = "#56CCF2";
        }

        start.position = 2;
        curAdition.position = 1;
        total.position = 0;

        start.percentage = getPercentage(start, total);
        curAdition.percentage = getPercentage(curAdition, total);
        total.percentage = getPercentage(total, total);

        if (start.percentage == 180) {
            curAdition.percentage = 0;
        }

        let chartBars = document.getElementsByClassName('bar');
        let animationArr = [];

        setTimeout(function() {
            for (let i = 0; i < chartBars.length; i++) {
                let animationValue = parseInt(chartBars[i].style.transform.replace('rotate(', '').replace('deg)', ''));
                chartBars[i].style.transform = 'rotate(' + (0) + 'deg)';
                animationArr.push(animationValue);
            }
            for (let i = 0; i < chartBars.length; i++) {
                setTimeout(function() { // jshint ignore:line
                    chartBars[i].classList.add('animation-start');
                    chartBars[i].style.transform = 'rotate(' + animationArr[i] + 'deg)';
                }, 600);
            }
        }, 10);
    };

    function getPercentage(actualField, totalField) {
        const totalPercent = 180;
        const initPercent = 0;
        if (actualField.isTotal) {
            return 180;
        }
        const newPercent = (actualField.valor * totalPercent) / totalField.valor;
        if (newPercent > totalPercent) {
            return totalPercent;
        }
        if (newPercent <= initPercent) {
            return initPercent;
        }
        return newPercent;
    }

    this.openTimeline = function(widget) {
        widget.currentRow = widget.parent.parent.currentRow;
        var filter = [{
            "name": "NRCONFIGALCADA",
            "operator": "=",
            "value": widget.currentRow.NRCONFIGALCADA
        }, {
            "name": "CDFILDEST",
            "operator": "=",
            "value": widget.currentRow.CDFILDEST
        }, {
            "name": "NRDEMANDA",
            "operator": "=",
            "value": widget.currentRow.NRDEMANDA
        }, {
            "name": "CDFILLANC",
            "operator": "=",
            "value": widget.currentRow.CDFILLANC
        }];
        widget.dataSourceFilter = filter;
        return widget.reload();
    };

    this.openItens = function(widget) {
        widget.currentRow = widget.parent.parent.currentRow;
        var filter = [{
            "name": "CDFILDEST",
            "operator": "=",
            "value": widget.currentRow.CDFILDEST
        }, {
            "name": "CDFILLANC",
            "operator": "=",
            "value": widget.currentRow.CDFILLANC
        }, {
            "name": "NRAUTOFORN",
            "operator": "=",
            "value": widget.currentRow.NRDEMANDA
        }];
        widget.dataSourceFilter = filter;
        return widget.reload();
    };

    function translateIntervalDate(date) {
        const dateFormat = 'DD/MM/YYYY';
        let baseDate;
        let modality;
        switch (date) {
            case 'hoje':
                baseDate = moment();
                modality = 'day';
                break;
            case 'amanha':
                baseDate = moment().add(1, 'day');
                modality = 'day';
                break;
            case 'ontem':
                baseDate = moment().subtract(1, 'day');
                modality = 'day';
                break;
            case 'proxima_semana':
                baseDate = moment().add(1, 'weeks');
                modality = 'week';
                break;
            case 'semana_anterior':
                baseDate = moment().subtract(1, 'weeks');
                modality = 'week';
                break;
            case 'semana_atual':
                baseDate = moment();
                modality = 'week';
                break;
            case 'proximo_mes':
                baseDate = moment().add(1, 'months');
                modality = 'month';
                break;
            case 'mes_anterior':
                baseDate = moment().subtract(1, 'months');
                modality = 'month';
                break;
            case 'mes_atual':
                baseDate = moment();
                modality = 'month';
                break;
        }
        return {
            start: baseDate.startOf(modality).format(dateFormat),
            end: baseDate.endOf(modality).format(dateFormat),
        };
    }

    this.setDateFilter = function(filterValues, widget) {
        let dataInicialFilter = widget.dataSourceFilter.find(filter => filter.name === 'DTINICIAL');
        let dataFinalFilter = widget.dataSourceFilter.find(filter => filter.name === 'DTFINAL');

        const {
            start,
            end
        } = translateIntervalDate(filterValues.DATA);

        dataInicialFilter.value = start;
        dataFinalFilter.value = end;
    };

    this.setOverviewFilter = function(filterValues, widget) {
        let CDOPERADORFilter = widget.dataSourceFilter.find(filter => filter.name === 'CDOPERADOR');
        let OPERADOR_LOGADOFilter = widget.dataSourceFilter.find(filter => filter.name === 'OPERADOR_LOGADO');
        let NRORGFilter = widget.dataSourceFilter.find(filter => filter.name === 'OPERADOR_LOGADO');
        let overviewStatus = filterValues.OVERVIEW;

        widget = templateManager.container.getActiveWidget();
        var filter = widget.dataSourceFilter;
        var filterElement = filter.find(function(filterEl) {
            return filterEl.name === 'IDAPROVADO';
        });

        if (overviewStatus === 'overviewActive' && filterElement.value !== 'PENDENTE') {
            CDOPERADORFilter.value = "T";
        } else if (overviewStatus === 'overviewInactive') {
            CDOPERADORFilter.value = getLocalVar('CDOPERADOR');
        }

        OPERADOR_LOGADOFilter.value = getLocalVar('CDOPERADOR');
        NRORGFilter.value = getLocalVar('NRORG');
    };

    this.prepareDataSourceFilter = function(filterValues) {
        const widget = templateManager.container.getWidget('alcadas');
        this.setDateFilter(filterValues, widget);
        this.setOverviewFilter(filterValues, widget);
    };
};

Configuration(function(ContextRegister) {
    ContextRegister.register('TasksController', TasksController);
});
